<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Mym00109AnalisePesquisaSatisfacaoController extends \Zeedhi\Framework\Controller\Report {

    protected $reportName;
    protected $crudService;
    protected $nrorg;
    protected $birtStrategy;
    protected $nrlista;
    protected $mym00109AnalisePesquisaSatisfacaoService;

    public function __construct(ReportService $reportService,$crudService, $birtStrategy ,$mym00109AnalisePesquisaSatisfacaoService) {
        $this->crudService = $crudService;
        $this->birtStrategy = $birtStrategy;
        $this->mym00109AnalisePesquisaSatisfacaoService = $mym00109AnalisePesquisaSatisfacaoService;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'MYM00100' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "NRQUESTIONARIO"   =>"P_NRQUESTIONARIO",
              "IDAPLICATIVO"     =>"P_IDAPLICATIVO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "DSTURNOLOCALPESQ" =>"P_TURNO"
            )
        ),
        'MYM00101' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "NRQUESTIONARIO"   =>"P_NRQUESTIONARIO",
              "IDAPLICATIVO"     =>"P_IDAPLICATIVO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "DSTURNOLOCALPESQ" =>"P_TURNO"
            )
        ),
        'MYM00102' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00103' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "IDCONSUMO"        =>"P_IDCONSUMO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00104' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "CDPICTPRAT"       =>"P_CDPICTPRAT",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00105' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "CDPICTPRAT"       =>"P_CDPICTPRAT",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00107' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "IDCONSUMO"        =>"P_IDCONSUMO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00108' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "IDCONSUMO"        =>"P_IDCONSUMO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),    
        'MYM00109' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "IDCONSUMO"        =>"P_IDCONSUMO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),
        'MYM00110' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "NRQUESTIONARIO"   =>"P_NRQUESTIONARIO",
              "IDAPLICATIVO"     =>"P_IDAPLICATIVO",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "DSTURNOLOCALPESQ" =>"P_TURNO"
            )
        ),    
        'MYM00111' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),            
        'MYM00112' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),            
        'MYM00113' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"P_NRLISTA",
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRORG"            =>"P_NRORG",
              "NMLOCALPESQ"      =>"P_LOCAL"
            )
        ),            
        'MYM00114' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "DTINICIO"         =>"P_DTINICIO",
              "DTFIM"            =>"P_DTFIM",
              "NRLISTA"          =>"P_NRLISTA",
              "NRQUESTIONARIO"   =>"P_NRQUESTIONARIO",
              "IDAPLICATIVO"     =>"P_IDAPLICATIVO",
              "NMLOCALPESQ"      =>"P_LOCAL",
              "DSTURNOLOCALPESQ" =>"P_TURNO",
              "NRORG"            =>"P_NRORG"
            )
        ),            
    );


    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->reportName = $row['REPORT_NAME'];
        $this->nrorg = $row['NRORG'];
        $row["LISTAFILIAL"] = '';
        
        if($row["NMLOCALPESQ"] != "T"){
           $row["NMLOCALPESQ"] = "_".$row["NMLOCALPESQ"]."_";
        }
        if($row["DSTURNOLOCALPESQ"] != "T"){
           $row["DSTURNOLOCALPESQ"] = "_".$row["DSTURNOLOCALPESQ"]."_";
        }        
        
        if (isset($row['QR2TYPE']) && $row['QR2TYPE']){
          $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        }
        
        if (isset($row['REPORT_NAME'])){
            if($row['REPORT_NAME'] === 'MYM00100' || 
               $row['REPORT_NAME'] === 'MYM00101' || 
               $row['REPORT_NAME'] === 'MYM00110' || 
               $row['REPORT_NAME'] === 'MYM00102' ||
               $row['REPORT_NAME'] === 'MYM00114'){
                   
                $listaFilial = $this->geraListaFilial($row['CDGRUPFILI'],$row['TODOSFILIAL'],$row);
            }else{
                $listaFilial = $this->geraListaServico($row);
            }
            $this->nrlista = $this->mym00109AnalisePesquisaSatisfacaoService->geraLista($this->nrorg, $listaFilial, '_');               
            $row['NRLISTA'] = $this->nrlista;
            $row['NRQUESTIONARIO'] = $row['QUESTIONARIO'];
            $row['IDAPLICATIVO'] = $row['APLICATIVO'];       
        }
    }
    
    public function geraListaFilial($agrupamento, $todos, $row){
        if ($todos === 'S'){
                $conditions = array(
                    array(
                        "columnName" => "CDOPERADOR",
                        "operator" => "=",
                        "value" => $this->crudService->getEnvironment()->getCdOperador()
                    ),
                    array(
                        "columnName" => "NRORG",
                        "operator" => "=",
                        "value" => $this->crudService->getEnvironment()->getNrOrg()
                    ),
                    array(
                        "columnName" => "CDGRUPFILI",
                        "operator" => "=",
                        "value" => isset($row["CDGRUPFILI"]) && !empty($row["CDGRUPFILI"]) ? $row['CDGRUPFILI'] : "T"
                    )
                );
                $resultFilais = $this->crudService->getFilteredDataSet('filial_operador_grupfili', $conditions)->getRows();
                $row["LISTAFILIAL"] = implode('_',array_column($resultFilais,'CDFILIAL'));
        }
        else{
             $row["LISTAFILIAL"] = $row["CDFILIAL"];
        }
        return $row["LISTAFILIAL"];
    }
    
    private function geraListaServico($row) {
        if ($row["ALLCDSERVFILI"] != "S") {
            return $row["SERVICO"];
        } else {
            $conditions = array(
                array(
                    "columnName" => "CDFILIAL",
                    "operator"   => '=',
                    "value"      => $row["TODOSFILIAL"] === "S" ? "T" : $row["CDFILIAL"]
                ),
                array(
                    "columnName" => "CDGRUPSERV",
                    "operator"   => '=',
                    "value"      => "T"
                ),
                array(
                    "columnName" => "CDOPERADOR",
                    "operator"   => '=',
                    "value"      => "OPERADOR_LOGADO"
                ),
                array(
                    "columnName" => "CDGRUPFILI",
                    "operator"   => '=',
                    "value"      => isset($row["CDGRUPFILI"]) && !empty($row["CDGRUPFILI"]) ? $row['CDGRUPFILI'] : "T"
                ),
                array(
                    "columnName" => "IDCNTRRESC",
                    "operator"   => '<>',
                    "value"      => 'S'
                )
            );
            $dataSet = $this->crudService->getFilteredDataSet("servico_operador_filgrupfili_filial_grupserv", $conditions);
            $rows = $dataSet->getRows();
            $cdfiliserv = array();
            foreach ($rows as $row) {
                array_push($cdfiliserv, $row["CHAVE"]);
            }
            return implode('_',$cdfiliserv);
        }
    }
}
